<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 The zen-cart developers                           |
// |                                                                      |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                      |
// | Portions Copyright (c) 2003 osCommerce                               |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+

  class cardia {
    var $code, $title, $description, $enabled, $proxy;

// class constructor
    function cardia() {
      global $order;
      $this->code = 'cardia';
      $this->title = MODULE_PAYMENT_CARDIA_TITLE;
      $this->description = MODULE_PAYMENT_CARDIA_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_CARDIA_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_CARDIA_STATUS == 'True') ? true : false);
      $this->icon = 'cardia.gif';

      if ((int)MODULE_PAYMENT_CARDIA_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_CARDIA_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      // load the Cardia class
      require(DIR_FS_CATALOG. DIR_WS_MODULES . 'payment/cardia/cardia.class.php');
      $this->proxy = new cardiaProxy();
    }

// class methods
    function update_status() {
      global $order, $db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_CC_ZONE > 0) ) {
        $check_flag = false;
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_CARDIA_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check->fields['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
          $check->MoveNext();
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }
   

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array(
        'id' => $this->code,
        'module' => $this->title,
        'icon' => $this->icon
      );
    }

    function pre_confirmation_check() {
    }

    function get_error() {

      $str = $_SESSION['cardia_errstr'];
      $_SESSION['cardia_errstr'] = '';

      if( !$str && ( $_SESSION['cardia_reference'] && $_SESSION['cardia_merchant_token'] ) ) {
        if( !$status = $this->proxy->transactionStatus( $_SESSION['cardia_merchant_token'], $_SESSION['cardia_reference'] ) )
          $str = $this->proxy->getError();
        else
          $str = (($status['authError'] ) ? "Remote error: Authorization error: _$status[authError]_ ":'').(($status['transError'] ) ? "  Transaction error: _$status[transError]_ ":'');
      }

      return array(
        'title' => MODULE_PAYMENT_CARDIA_ERROR_TITLE,
        'error' => strip_tags( $str )
      );
    }

    function confirmation() {

      // this method will prepare a GUID and set the
      // form action url - effectively sending the customer to
      // cardia for payment

      global $order, $currencies, $currency, $form_action_url;

      // Check what currency to use
      
      $_SESSION['cardia_reference'] = substr( uniqid( $_SESSION['customer_id'].'_' ), 0 ,20 );
      
      $order_currency = $order->info['currency'];
      $_SESSION['cardia_merchant_token'] = @constant( 'MODULE_PAYMENT_CARDIA_'.$order->info['currency'].'_TOKEN' );
      if( !$_SESSION['cardia_merchant_token'] ) {
        $order_currency = DEFAULT_CURRENCY;
        $_SESSION['cardia_merchant_token'] = @constant( 'MODULE_PAYMENT_CARDIA_'.DEFAULT_CURRENCY.'_TOKEN' );
      }

      if( !$_SESSION['cardia_merchant_token'] ) {
        // No token for default currency either, show an errormessage
        $_SESSION['cardia_errstr']= 'There are no Tokens available - check your config, and add a token for the default currency';
        $this->form_action_url = zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code, 'SSL',false,false);
        return false;
      }

      $order_amount = str_replace( array(',','.'), ',', $order->info['total'] * $currencies->get_value( $order_currency ) );

      $params = array(
        'merchantToken'             => $_SESSION['cardia_merchant_token'],
        'testmode'                  => (( MODULE_PAYMENT_CARDIA_TESTMODE == 'True' ) ? true : false ),
        'store'                     => MODULE_PAYMENT_CARDIA_STORE_NAME,
        'orderDescription'          => sprintf( MODULE_PAYMENT_CARDIA_ORDER_DESCRIPTION, date('d.m.Y') ) . (( $order_currency != $order->info['currency'] ) ? ' ('.$currencies->format( $order->info['total'], true, $order->info['currency'] ).')':''),
        'merchantReference'         => $_SESSION['cardia_reference'],
        'currencyCode'              => $order_currency,
        'amount'                    => $order_amount,
        'isOnHold'                  => ((MODULE_PAYMENT_CARDIA_TRANSACTION_MODE == 'Auth' ) ? 'true' : 'false' ),
        'skipFirstPage'             => MODULE_PAYMENT_CARDIA_SKIP_FIRST_PAGE,
        'skipLastPage'              => 'true',
        'useThirdPartySecurity'     => MODULE_PAYMENT_CARDIA_USE_3RD_SECURITY,
        'paymentMethod'             => $this->proxy->getPaymentMethods( MODULE_PAYMENT_CARDIA_PAYMENT_METHOD ),
        'successfulTransactionUrl'  => zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', true, false),
        'unsuccessfulTransactionUrl' => str_replace( '&amp;','&', zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code, 'SSL', true, false)), // need & instead of the entity
        'authorizedNotAuthenticatedUrl' => ''
      );

      // Send it and check for errors
      if( !$this->proxy->createGUID( $params ) ) {
         $_SESSION['cardia_errstr'] = $this->proxy->getError();
         //$this->form_action_url = zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code, 'SSL',false,false);
         $form_action_url = zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code, 'SSL',false,false);
         return false;
      }

      // still here means it's ok so far
      //$this->form_action_url = $this->proxy->terminalURL.'?guid='.$this->proxy->referenceGUID;
      $form_action_url = $this->proxy->terminalURL.'?guid='.$this->proxy->referenceGUID;
      return false;
    }


    function process_button() {
      return $process_button_string;
    }

    function before_process() {
      
      unset( $error );
      if( !$status = $this->proxy->transactionStatus( $_SESSION['cardia_merchant_token'], $_SESSION['cardia_reference'] ) )
        $error = true;

      if( $status['hasError'] )
        $error = true;

      if($error) {
        zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code, 'SSL',true,false));
        return false;
      }
    }

    function after_order_create($zf_order_id) {
      global $db;
      
      if( $_SESSION['cardia_reference'] && $_SESSION['cardia_merchant_token'] )
        $db->Execute( 'update ' . TABLE_ORDERS . ' set cc_owner="'.$_SESSION['cardia_merchant_token'].'", cc_number="'.$_SESSION['cardia_reference'].'" where orders_id='. $zf_order_id );
      
      // clear settings
      $_SESSION['cardia_reference'] = $_SESSION['cardia_merchant_token'] = '';
      return false;
    }

    function after_process() {
      
    }
 
    function admin_notification() {
      global $order;
      if( eregi( CARDIA_GUID_REGEXP, $order->info['cc_owner'] ) ) {
        $status = $this->proxy->transactionStatus( $order->info['cc_owner'], $order->info['cc_number'] );
        $info = "<tr><td style='background: #FFFFE1; border: 1px solid #666; margin: 5px; padding: 5px; color:". (( $status['hasFault'] ) ? '#f00':'#666' ).";'><b>Realtime transaction status:</b> ";
        if( $status['hasFault'] ) {
          $info .= "<b>NOT OK</b><br>Authentication error:".(($status['authError'])?$status['authError']:'-' )."<br />\n";
          $info .= "<b>NOT OK</b><br>Transaction error:".(($status['transError'])?$status['transError']:'-' )."<br />\n";
        } else {
          $info .= "<b>OK</b><br />\n";
        }
        $info .= "Amount: <b>$status[currencyCode] $status[amount]</b><br />Reference: ".$order->info['cc_number']."<br /></td></tr>\n";
        return $info;
      }
    }
 
    function check() {
      global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_CARDIA_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
      global $db;
      $this->remove();
      /*

       POST INSTALL CHECKS
       This will ABORT the installation if server requirements are not met

      */

      if( !$this->proxy->testConnection() ) die( "Location: local. Sorry, this module relies on the Client URL Library (CURL) for connectivity.<br>".$this->proxy->getError() );

      
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable cardia.no Module', 'MODULE_PAYMENT_CARDIA_STATUS', 'True', 'Do you want to accept cardia.no payments?', '6', ".(++$sort).", 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Store name', 'MODULE_PAYMENT_CARDIA_STORE_NAME', 'test store', 'The name of the store that should be show to the customer when entering their card details.', '6', ".(++$sort).", now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Testmode Terminal?', 'MODULE_PAYMENT_CARDIA_TESTMODE', 'True', 'If set to true - the terminal is in testmode. Use card number 4444333322221111 expire 0309 cvc 081 for testing.', '6', ".(++$sort).", 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_CARDIA_TRANSACTION_MODE', 'Auth', 'If set to auth, payment is authorized but NOT charged.', '6', ".(++$sort).", 'zen_cfg_select_option(array(\'Auth\', \'Sale\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use 3rd party security?', 'MODULE_PAYMENT_CARDIA_USE_3RD_SECURITY', 'False', 'If set to true, transaction goes through Verified by Visa (VbV) or Secure Code (MasterCard SC).', ".(++$sort).", ".(++$sort).", 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Skip first page?', 'MODULE_PAYMENT_CARDIA_SKIP_FIRST_PAGE', 'False', 'When this is set to true, the first page in the Cardia payment dialog will not be shown to the customer. Set it to true if you use only one payment method.', '6', ".(++$sort).", 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");

      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Payment method', 'MODULE_PAYMENT_CARDIA_PAYMENT_METHOD', 'Credit Card', 'Works together with skip first page. Set payment method.', '6', ".(++$sort).", 'zen_cfg_select_option(array(\'".implode( "\',\'", $this->proxy->getPaymentMethods() )."\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_CARDIA_SORT_ORDER', '0', 'Sort order of display.', '6', ".(++$sort).", now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_CARDIA_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', ".(++$sort).", 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_CARDIA_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', ".(++$sort).", 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");

      $currencies = $db->Execute( "select * from ".TABLE_CURRENCIES." where code in( '".implode( "','", $this->proxy->getCurrencies() )."')" );
      while( !$currencies->EOF ) {
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Cardia Merchant Token <b>".$currencies->fields['code']."</b>', 'MODULE_PAYMENT_CARDIA_".$currencies->fields['code']."_TOKEN', '".(($currencies->fields['code']=='NOK')?'CF4B6B54-6C28-4FA3-86B0-E9A347D75C6C':'')."', 'Merchant token for ".$currencies->fields['code']." assigned by Cardia. Leave blank if you have no token for this currency', '6', ".(++$sort).", now())");
        $currencies->MoveNext(); 
      }
    }

    function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE_PAYMENT_CARDIA_%'" );
    }

    function keys() {
      global $db;
      // add keys for allowable currencies

      $keys = $db->Execute( "select configuration_key from ".TABLE_CONFIGURATION." where configuration_key like 'MODULE_PAYMENT_CARDIA_%' order by sort_order" );
      while( !$keys->EOF ) {
        $return_keys[] = $keys->fields['configuration_key'];
        $keys->MoveNext();
      }
      
      return $return_keys;
    }
  }
?>
